//+------------------------------------------------------------------+
//|                                                     forecast.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue

extern int Length=20;
extern ENUM_APPLIED_PRICE Price=0;    // Applied price
extern int SmoothPeriod = 5;

double FO[];

int init()
{
 IndicatorShortName("Forecast Oscillator");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(0,FO);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
 if(Bars<=3) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 int pos;
 double sx, sy, sxy, sx2, a, b, tsf;
 double Pr;
 int i, t;
 pos=limit;
 while(pos>=0)
 {
  t=Length;
  sx=0.;
  sy=0.;
  sxy=0.;
  sx2=0.;
  for (i=pos+Length;i>=pos+1;i--)
  {
   Pr=iMA(NULL, 0, 1, 0, MODE_SMA, Price, i);
   sy=sy+Pr;
   sx=sx+t;
   sx2=sx2+t*t;
   sxy=sxy+Pr*t;
   t--;
  }
  b=(Length*sxy-sx*sy)/(Length*sx2-sx*sx);
  a=(sy-b*sx)/Length;
  tsf=a+b;
  
  Pr=iMA(NULL, 0, 1, 0, MODE_SMA, Price, pos);
  if (Pr!=0.)
   FO[pos]=iSsm(100.*(Pr-tsf)/Pr,SmoothPeriod,pos);

  pos--;
 } 
 return(0);
}


    //------------------------------------------------------------------
    //
    //------------------------------------------------------------------
    //
    //
    //
    //
    //

    double workSsm[][2];
    #define _price 0
    #define _ssm 1

    double workSsmCoeffs[][4];
    #define _period 0
    #define _c1 1
    #define _c2 2
    #define _c3 3
    #define Pi 3.14159265358979323846264338327950288

    //
    //
    //
    //
    //

    double iSsm(double price, double period, int i, int instanceNo=0)
    {
    if (period<=1) return(price);
    if (ArrayRange(workSsm,0) !=Bars) ArrayResize(workSsm,Bars);
    if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
    if (workSsmCoeffs[instanceNo][_period] != period)
    {
    workSsmCoeffs[instanceNo][_period] = period;
    double a1 = MathExp(-1.414*Pi/period);
    double b1 = 2.0*a1*MathCos(1.414*Pi/period);
    workSsmCoeffs[instanceNo][_c2] = b1;
    workSsmCoeffs[instanceNo][_c3] = -a1*a1;
    workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
    }

    //
    //
    //
    //
    //

    i = Bars-i-1;
    int s = instanceNo*2;
    workSsm[i][s+_price] = price;
    workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 +
    workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm] +
    workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
    return(workSsm[i][s+_ssm]);
    } 

